
function getFoldersList(selectLastItem)
{

    var request = new XMLHttpRequest();
    let sessionId = localStorage.getItem('sessionId');
    request.open('GET', "/api/folders?sessionId=" + sessionId, true);

    request.setRequestHeader("content-type","application/json");
    request.send();
    request.onreadystatechange = function() {

        if (request.readyState == 4 && (request.status == 200 || request.status == 0)) {
            var result = JSON.parse(request.responseText);

            if (result.folders) {
                result.folders.forEach(folder => {
                    addFolder(folder.name, folder.$urls.dataSync, folder.$urls.dataService);
                });
                if (selectLastItem){
                    $('#folder option:last').prop('selected', true);
                }
            }
            loadCurlCommands();

        } else if (request.readyState == 4 ) {
            var result = JSON.parse(request.responseText);
            $('#alertMessageContent').text(result.message);
            $('#alertMessage').show();
            loadCurlCommands();
        }
    };
}

function addFolder(folderName, syncUrl, graphQlUrl){
    let item = document.createElement("option");
    item.textContent = folderName;
    let syncUrlAttribute = document.createAttribute("syncUrl");
    syncUrlAttribute.value = syncUrl;
    item.setAttributeNode(syncUrlAttribute);
    let graphqlUrlAttribute = document.createAttribute("graphQLUrl");
    graphqlUrlAttribute.value = graphQlUrl;
    item.setAttributeNode(graphqlUrlAttribute);
    $("#folder").append(item);
}