let request = require('./requestLib');

exports.getFoldersList = async function (req, res, tokenHandler) {
    await getFolders(req, res, tokenHandler, true);
};

let getFolders = async function (req, res, tokenHandler, canRefreshToken) {

    console.log(process.env.ENDPOINT_URL + "/folders");
    try {
        let result = await request.get(req,{headers: {'content-type': 'application/json', 'Authorization': 'Bearer ' + tokenHandler.accessToken()}, url: process.env.ENDPOINT_URL + "/folders"}, true)
        if (result.statusCode === 200) {
            console.log(JSON.stringify(result));
            res.send(result.body);
        } else if (result.statusCode === 401 && canRefreshToken) {
            await tokenHandler.getNewAccessTokenFromRefreshToken(req);
            await getFolders(req, res, tokenHandler, false);
        } else {
            let message = "An error occured";
            let body = JSON.parse(result.body);
            if (body && body.message) {
                message = body.message;
            }
            res.status(400).send('{"message": "' + message + '"}');
        }
    } catch (error) {
        res.status(400).send('{"message": "' + error + '"}');
    }

};
