let request = require('./requestLib');

exports.getTracking = async function(req, res, tokenHandler) {
    await getTracking(req, res, tokenHandler, true);
};

let getTracking = async function(req, res, tokenHandler, canRefreshToken) {
    try {
        let result = await request.get(req,{headers: {'content-type' : 'application/json', 'Authorization': 'Bearer ' + tokenHandler.accessToken()}, url: process.env.ENDPOINT_URL + "/dataingestion/tracking/" + req.body.file_tracking_id}, true);
        if (result && result.statusCode) {
            if (result.statusCode === 200) {
                let body = JSON.parse(result.body);
                res.send(body);
            } else if (result.statusCode === 401 && canRefreshToken) {
                await tokenHandler.getNewAccessTokenFromRefreshToken(req);
            }  else {
                let message = "An error occurred";
                let body = JSON.parse(result.body);
                if (body && body.message) {
                    message = body.message;
                }
                res.status(400).send('{"message": "' + message + '"}');
            }
        }
    } catch (error) {
        res.status(400).send('{"message": "' + error + '"}');
    }

};

let doRequest = function(context) {
    context.followRedirect = false;
    return new Promise(function (resolve, reject) {
        request.get(context, function (error, response, body) {
            if (!error) {
                if (response.statusCode === 301) {
                    context.url = response.headers.location;
                    console.log("Redirect to " + context.url);
                    doRequest(context).then((response, error) => {
                        console.log(JSON.stringify(response));
                        if (error) {
                            reject(error);
                        } else {
                            resolve({statusCode: response.statusCode, body: response.body});
                        }

                    });
                } else {
                    resolve({statusCode: response.statusCode, body: body});
                }
            } else {
                reject(error);
            }
        });
    });
};