let request = require('./requestLib');
let jwt = require('jsonwebtoken');

let token = {
    access_token: "",
    refresh_token: ""
};

exports.decodeCurrentToken = function (req, res) {
    res.send(jwt.decode(req.body.token));
};

exports.accessToken = function() {
    return token.access_token;
};
exports.refreshToken = function() {
    return token.refresh_token;
};
exports.refreshTokenExpiresIn = function() {
    return token.refresh_token_expires_in;
};
exports.initiate = async function(req, res, bgColor, buttonColor) {
    let redirectUrl = process.env.REDIRECT_URL ? process.env.REDIRECT_URL : process.env.ENV_URL + "/callback";
    let data = {
            code: req.body.access_code_or_refresh_token,
            client_id: process.env.CLIENT_ID,
            client_secret: process.env.CLIENT_SECRET,
            grant_type: "authorization_code",
            redirect_uri: redirectUrl
        };

    console.log(process.env.ENDPOINT_URL + "/api/token" + data);


    let response = await  request.post(req, {headers: {'content-type' : 'application/json'}, url:process.env.ENDPOINT_URL + "/token", body: JSON.stringify(data)});

        if (response && response.statusCode) {
            console.log(response.statusCode);
            if (response.statusCode === 201) {
                let result = JSON.parse(response.body);
                token = result;
                res.send(result);
            } else {
                let message = "An error occurred";
                let result = JSON.parse(response.body);
                if (result && result.message) {
                    message = result.message;
                }
                res.status(400).send('{"message": "' + message + '"}');
            }
        }

};

exports.refresh = async function(req, res, refreshToken) {
    console.log(refreshToken ? refreshToken : req.body.access_code_or_refresh_token);

    let data = {
        refresh_token: refreshToken ? refreshToken : req.body.access_code_or_refresh_token,
        client_id: process.env.CLIENT_ID,
        client_secret: process.env.CLIENT_SECRET,
        grant_type: "refresh_token"
    };

    console.log(process.env.ENDPOINT_URL + "/api/token" + data);

    console.log("refresh call");
    let response = await  request.post(req,{headers: {'content-type' : 'application/json'}, url:process.env.ENDPOINT_URL + "/token", body: JSON.stringify(data) }, true);

        if (response && response.statusCode) {
            if (response.statusCode === 201) {
                let result = JSON.parse(response.body);
                console.log(response.body);
                token = result;
                res.send(result);
            } else {
                let message = "An error occured";
                let result = JSON.parse(response.body);
                if (result && result.message) {
                    message = result.message;
                }
                if (response.statusCode === 404) {
                    message = "refresh token does not exists";
                }
                res.status(400).send('{"message": "' + message + '"}');
            }
        }

};


exports.delete = async function(req, res, refreshToken) {
    console.log(refreshToken ? refreshToken : req.body.access_code_or_refresh_token);
    let data =
        "?refresh_token="  + (refreshToken ? refreshToken : req.body.access_code_or_refresh_token) +
        "&client_id=" + process.env.CLIENT_ID +
        "&client_secret=" + process.env.CLIENT_SECRET;


    console.log(process.env.ENDPOINT_URL + "/api/token" + data);

    console.log("delete call");
    let response = await  request.delete(req,{headers: {'content-type' : 'application/json'}, url:process.env.ENDPOINT_URL + "/token" + data});

        console.log("Response status: " +response.statusCode);
        if (response && response.statusCode) {
            if ((response.statusCode === 200) || (response.statusCode === 201)) {
                console.log(" ============== DELETE DONE ================");
                res.status(200).send("{}");
            } else {
                let message = "An error occured";
                let result = JSON.parse(body);
                if (result && result.message) {
                    message = result.message;
                }
                res.status(400).send('{"message": "' + message + '"}');
            }
        }

};

exports.getNewAccessTokenFromRefreshToken = async function(req) {
    if (!token.refresh_token) {
        throw new Error("Refresk token needed");
    }
    let data = {
        refresh_token: token.refresh_token,
        client_id: process.env.CLIENT_ID,
        client_secret: process.env.CLIENT_SECRET,
        grant_type: "refresh_token"
    };

    console.log(process.env.ENDPOINT_URL + "/api/token" + data);
    let result = await request.post(req, {headers: {'content-type' : 'application/json'}, url:process.env.ENDPOINT_URL + "/token" , body: JSON.stringify(data)});

    if (result && result.statusCode) {
        if (result.statusCode === 201) {
            let body = JSON.parse(result.body);
            console.log(body);
            token = body;
            return body;
        } else {
            let message = "An error occured while refreshing access token";
            let body = JSON.parse(result.body);
            if (body && body.message) {
                message += ": " + body.message;
            }
            throw new Error(message);
        }
    }
};
